"use strict";
/**
 * @license
 * Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
 * This code may only be used under the BSD style license found at
 * http://polymer.github.io/LICENSE.txt
 * The complete set of authors may be found at
 * http://polymer.github.io/AUTHORS.txt
 * The complete set of contributors may be found at
 * http://polymer.github.io/CONTRIBUTORS.txt
 * Code distributed by Google as part of the polymer project is also
 * subject to an additional IP rights grant found at
 * http://polymer.github.io/PATENTS.txt
 */
Object.defineProperty(exports, "__esModule", { value: true });
// Install source map support for stack traces, etc.
require('source-map-support').install();
const path = require("path");
const child_process_1 = require("mz/child_process");
const fs_1 = require("mz/fs");
const convert_package_1 = require("../convert-package");
const repoUrl = 'https://github.com/Polymer/polymer.git';
const fixturesDirPath = path.resolve(__dirname, '../../fixtures/generated/polymer');
const sourceDir = path.join(fixturesDirPath, 'source');
const convertedDir = path.join(fixturesDirPath, 'expected');
(async () => {
    await child_process_1.exec(`mkdir -p ${fixturesDirPath}`);
    if (!await fs_1.exists(sourceDir)) {
        console.log(`Cloning ${repoUrl} to ${sourceDir}...`);
        await child_process_1.exec('git clone https://github.com/Polymer/polymer.git source --depth=1', { cwd: fixturesDirPath });
    }
    console.log(`Converting...`);
    await convert_package_1.convertPackage({
        inDir: sourceDir,
        outDir: convertedDir,
        clearOutDir: true,
        packageName: '@polymer/polymer',
        packageVersion: '3.0.0',
    });
    console.log(`Done.`);
})();
//# sourceMappingURL=checkpoint-polymer.js.map