/**
 * Checks if an element has a given CSS text
 *
 * @param {HTMLElement} el
 * @param {string} cssText
 */
function sameCSS(el, cssText) {
  var propName;
  var dummy = document.createElement('div');

  dummy.style.cssText = cssText;
  document.body.appendChild(dummy);

  var elStyle = window.getComputedStyle(el);
  var parts = cssText.split(/\s/);
  var dummyStyle = window.getComputedStyle(dummy);

  for (var i = 0; i < parts.length; i++) {
    if (parts[i].substr(-1, 1) != ':') {
      continue;
    }

    propName = parts[i].substr(0, parts[i].length - 1);

    if (elStyle[propName] && elStyle[propName] !== dummyStyle[propName]) {
      throw new Error('`' + propName + '` is different: ' +
        '`' + elStyle[propName] + '` != `' + dummyStyle[propName] + '`');
    }
  }
  return true;
}
