import '../../../polymer/polymer.js';
import '../../../iron-flex-layout/iron-flex-layout.js';
import { NeonAnimatableBehavior } from '../../neon-animatable-behavior.js';
import { NeonAnimationRunnerBehavior } from '../../neon-animation-runner-behavior.js';
import '../../../paper-styles/shadow.js';
import './animated-grid.js';
import { Polymer } from '../../../polymer/lib/legacy/polymer-fn.js';

Polymer({
  _template: `
    <style>
      :host {
        background: black;
        visibility: hidden;
        @apply --layout-vertical;
      }

      .toolbar {
        background: #9c27b0;
        height: 72px;
        z-index: 1;
        @apply --shadow-elevation-2dp;
      }

      animated-grid {
        height: calc(100% - 72px);
        @apply --layout-flex;
      }
    </style>

    <div id="toolbar" class="toolbar"></div>
    <animated-grid id="grid"></animated-grid>
`,

  is: 'full-page',

  behaviors: [
    NeonAnimatableBehavior,
    NeonAnimationRunnerBehavior
  ],

  properties: {

    animationConfig: {
      type: Object
    }
  },

  attached: function() {
    this.animationConfig = this.animationConfig || {
      'entry': [{
        name: 'slide-from-top-animation',
        node: this.$.toolbar
      }, {
        animatable: this.$.grid,
        type: 'entry'
      }]
    };
  },

  show: function() {
    this.style.visibility = 'visible';
    this.playAnimation('entry');
  }
});
