import '../polymer/polymer.js';
import './paper-text-field-shared-styles.js';
import { PaperTextFieldBehavior } from './paper-text-field-behavior.js';
import { Polymer } from '../polymer/lib/legacy/polymer-fn.js';
const $_documentContainer = document.createElement('div');
$_documentContainer.setAttribute('style', 'display: none;');

$_documentContainer.innerHTML = `<dom-module id="paper-password-field">
  <!-- TODO(noms): When inheritance is available, inherit the template from
    a base text-field -->
  <template>
    <style include="paper-text-field-shared-styles"></style>

    <div class="container">
      <label hidden\$="[[!label]]" class\$="[[_computeLabelClass(noFloatLabel,alwaysFloatLabel,hasContent)]]">[[label]]</label>
      <input id="input" type="password" tabindex="-1"></div>
    
    
  </template>
</dom-module>`;

document.head.appendChild($_documentContainer);
Polymer({
  is: 'paper-password-field',

  hostAttributes: {
    'tabindex': 0,
    'role': 'textbox'
  },

  behaviors: [
    PaperTextFieldBehavior
  ],

  _setUpListeners: function() {
    this.inputElement.addEventListener('input', this._onInput.bind(this));
  },

  set inputElementValue(value) {
    this.inputElement.value = value;
  },

  get inputElementValue() {
    return this.inputElement.value;
  },
});
